"use strict";
this.name        = "safetycatch";
this.author      = "Norby";
this.copyright   = "2013 Norbert Nagy";
this.licence     = "CC BY-NC-SA 4.0";
this.description = "Use to prevent unwanted launch of your mines.";

//customizable properties
this.$SafetyCatchQMineOnly = true; //turn off if you use custom mines also, but test it carefully
//due to ffutures reported the following bug using the custom-mines code:
//"it gave me two mines although there was only one loaded - the next time TWO appeared after I fired."

//internal properties, should not touch
this.$SafetyCatchIsSafe = true; //true if catch currently prevent launching mines
this.$SafetyCatchMines = []; //array of guarded mines to award these back when catch turned off

//world script events
this.startUp = function() {
	this.$SafetyCatchIsSafe = false; //true if catch currently prevent launching mines
	var m = player.ship.missiles;
	var i=-1;
	while(m[++i]) {
		if( m[i].equipmentKey == "EQ_SAFETY_MINE" ) {
			this.$SafetyCatchIsSafe = true; //true if catch currently prevent launching mines
		}
	}

	var mv = missionVariables.$SafetyCatchMines;
	if( !mv ) this.$SafetyCatchMines = []; //array of guarded mines to award these back when catch turned off
	else if( (mv+"").indexOf(",") ) this.$SafetyCatchMines = (mv+"").split(","); //need +"" for bugfix
	else this.$SafetyCatchMines = [mv];
}

this.equipmentDamaged = this.equipmentDestroyed = function(equipment) {
	if( equipment == "EQ_SAFETYCATCH" ) this.$SafetyCatchOff();
}

this.equipmentRepaired = function(equipment) {
	if( equipment == "EQ_SAFETYCATCH" ) this.$SafetyCatchOn();
}

this.playerBoughtEquipment = function(equipmentKey) {
	if( equipmentKey == "EQ_SAFETYCATCH" ) {
		this.$SafetyCatchOn();
//		player.ship.setEquipmentStatus("EQ_SAFETYCATCH", "EQUIPMENT_DAMAGED");//test of repair cost
	}
 	if( ( equipmentKey == "EQ_QC_MINE" && this.$SafetyCatchQMineOnly || !this.$SafetyCatchQMineOnly &&
		equipmentKey != "EQ_SAFETY_MINE" && equipmentKey.substr(-5,5) == "_MINE" )
		&& player.ship.equipmentStatus("EQ_SAFETYCATCH") == "EQUIPMENT_OK" ) {
		this.$SafetyCatchMines.push( equipmentKey );
		player.ship.removeEquipment( equipmentKey );
		player.ship.awardEquipment( "EQ_SAFETY_MINE" );
		player.consoleMessage("Your new mine is in safe state.");
	}
}

this.playerWillSaveGame = function(message) {
	missionVariables.$SafetyCatchMines = this.$SafetyCatchMines;
}

//SafetyCatch methods
this.$SafetyCatchOn = function() { //replace mines with safety mines
	if( player.ship.equipmentStatus("EQ_SAFETYCATCH") != "EQUIPMENT_OK" ) return; //damaged or not installed
	
	var w = worldScripts["safetycatch"];
	var k = "";
	var m = player.ship.missiles;
	var oldlength = w.$SafetyCatchMines.length;
	var i=-1;
	while(m[++i]) {
		k = m[i].equipmentKey;
		if( w.$SafetyCatchQMineOnly && k == "EQ_QC_MINE" || !w.$SafetyCatchQMineOnly &&
			k != "EQ_SAFETY_MINE" && k.substr(-5,5) == "_MINE" ) {
			w.$SafetyCatchMines.push( k );
			player.ship.removeEquipment( k );
			if( w.$SafetyCatchQMineOnly )
				player.ship.awardEquipment( "EQ_SAFETY_MINE" );
		}
//		log("safetycatch", k+" "+k.substr(-5,5)+" "+w.$SafetyCatchMines);
	}
	var newlength = w.$SafetyCatchMines.length;
	if( !w.$SafetyCatchQMineOnly )
		for( var i = oldlength; i < newlength; i++ )
			player.ship.awardEquipment( "EQ_SAFETY_MINE" );
	w.$SafetyCatchIsSafe = true;
	player.consoleMessage("Mines in safe state.");
}

this.$SafetyCatchOff = function() {  //replace safety mines with saved mines
	var w = worldScripts["safetycatch"];
	if( w.$SafetyCatchQMineOnly ) {
		var m = player.ship.missiles;
		var s = 0;
		for( var i = 0; i < m.length; i++ )
			if( m[i].equipmentKey == "EQ_SAFETY_MINE" ) s++;
		for( var i = 0; i < s; i++ ) {
			player.ship.removeEquipment( "EQ_SAFETY_MINE" );
			player.ship.awardEquipment( "EQ_QC_MINE" );
		}
	} else {
		var m = w.$SafetyCatchMines;
		for( var i = 0; i < m.length; i++ ) {
			player.ship.removeEquipment( "EQ_SAFETY_MINE" );
			player.ship.awardEquipment( m[i] );
		}
	}
	delete w.$SafetyCatchMines;
	w.$SafetyCatchMines = [];
	w.$SafetyCatchIsSafe = false;
	player.consoleMessage("Mines ARMED!");
}